//	complex.hh

#include <iostream.h>

// #######################################################
//		Complex number class
// #######################################################

class Complex
{
//			Data
 private:
   double re, im;	// real an imaginary part of complex number

//			Methods
 public:
//			Standard and parameter constructor  
  Complex(const double re_in = 0.0 , const double im_in = 0.0)
  	{ re = re_in; im = im_in;};

//			Copy constructor (the same as the default)
  Complex(const Complex & orig)
  	{ re = orig.Re(); im = orig.Im(); };

//			Destructor (the same as the default)
  ~Complex() {};


//			Access Methods
  const double& Re() const {return re;};
  const double& Im() const {return im;};
        double& Re()       {return re;};
        double& Im()       {return im;};

//		Operators  
//			Assignment operator:    this = orig
  Complex& operator=(const Complex & orig)
  	{ re = orig.Re(); im = orig.Im(); return *this;  };

//			Operator:  this += v
  Complex& operator+=(const Complex & v) 
  	{ Re() += v.Re();  Im() += v.Im(); return *this;  };
};

// --------------------------------------------------------------
//		Methoden, welche eigentlich Funktionen sind
// --------------------------------------------------------------

//			Print
 ostream & operator<<(ostream & s, const Complex & orig) 
 	{  return s << orig.Re() << " + " <<  orig.Im() << "i   "; };

//			Input
 istream & operator>>(istream & s, Complex & orig) 
 	{  return s >> orig.Re() >>  orig.Im(); };

//			tmp <--  x + y
 Complex operator+(const Complex & x, const Complex & y)
  	{ 
	  Complex tmp(x.Re()+y.Re(), x.Im()+y.Im());
//	  tmp.Re() =  x.Re()+y.Re();
	  return tmp;
	};
//			tmp <--  x - y
 Complex operator-(const Complex & x, const Complex & y)
  	{ 
	  return Complex(x.Re()-y.Re(), x.Im()-y.Im()); 
	};
    
//			tmp <--  x * y
 Complex operator*(const Complex & x, const Complex & y)
  	{ 
	  return Complex(x.Re() * y.Re() - x.Im() * y.Im(), 
	  		 x.Re() * y.Im() + x.Im() * y.Re() ); 
	};

//			tmp <--  scal * y
 Complex operator*(const double & scal, const Complex & y)
  	{ 
	  return Complex(scal* y.Re(), scal * y.Im() ); 
	};
























